# Copyright (c) 2000-2013, JPackage Project
# All rights reserved.
#
# Redistribution and use in source and binary forms, with or without
# modification, are permitted provided that the following conditions
# are met:
#
# 1. Redistributions of source code must retain the above copyright
#    notice, this list of conditions and the following disclaimer.
# 2. Redistributions in binary form must reproduce the above copyright
#    notice, this list of conditions and the following disclaimer in the
#    documentation and/or other materials provided with the
#    distribution.
# 3. Neither the name of the JPackage Project nor the names of its
#    contributors may be used to endorse or promote products derived
#    from this software without specific prior written permission.
#
# THIS SOFTWARE IS PROVIDED BY THE COPYRIGHT HOLDERS AND CONTRIBUTORS
# "AS IS" AND ANY EXPRESS OR IMPLIED WARRANTIES, INCLUDING, BUT NOT
# LIMITED TO, THE IMPLIED WARRANTIES OF MERCHANTABILITY AND FITNESS FOR
# A PARTICULAR PURPOSE ARE DISCLAIMED. IN NO EVENT SHALL THE COPYRIGHT
# OWNER OR CONTRIBUTORS BE LIABLE FOR ANY DIRECT, INDIRECT, INCIDENTAL,
# SPECIAL, EXEMPLARY, OR CONSEQUENTIAL DAMAGES (INCLUDING, BUT NOT
# LIMITED TO, PROCUREMENT OF SUBSTITUTE GOODS OR SERVICES; LOSS OF USE,
# DATA, OR PROFITS; OR BUSINESS INTERRUPTION) HOWEVER CAUSED AND ON ANY
# THEORY OF LIABILITY, WHETHER IN CONTRACT, STRICT LIABILITY, OR TORT
# (INCLUDING NEGLIGENCE OR OTHERWISE) ARISING IN ANY WAY OUT OF THE USE
# OF THIS SOFTWARE, EVEN IF ADVISED OF THE POSSIBILITY OF SUCH DAMAGE.
#

%define section  free
%define _binary_payload w9.gzdio
%define _source_payload w9.gzdio
%define _binary_filedigest_algorithm 1
%define _source_filedigest_algorithm 1

Name:           apache-xjc-utils
Version:        2.4.0
Release:        2%{?dist}
Epoch:          0
Summary:        CXF XJC Utilities 
License:        ASL 2.0
Group:          Development/Java
URL:            http://cxf.apache.org/
Source0:        xjc-utils-2.4.0.tgz
# svn export http://svn.apache.org/repos/asf/cxf/xjc-utils/tags/xjc-utils-2.4.0/
# tar czf xjc-utils-2.4.0.tgz xjc-utils-2.4.0/

Source1:        %{name}-settings.xml
Source2:        %{name}-jpp-depmap.xml
Patch0:         apache-xjc-utils-pom.patch

BuildRequires:  jpackage-utils >= 0:1.7.5
BuildRequires:  java-devel >= 0:1.6.0

BuildRequires:  maven2 >= 0:2.0.8
BuildRequires:  maven2-plugin-compiler
BuildRequires:  maven2-plugin-install
BuildRequires:  maven2-plugin-jar
BuildRequires:  maven2-plugin-javadoc
BuildRequires:  maven2-plugin-plugin
BuildRequires:  maven-surefire-plugin
BuildRequires:  maven-surefire-provider-junit4
BuildRequires:  sun-jaxb-2.1-api
BuildRequires:  sun-jaxb-2.1-impl

BuildArch:      noarch
BuildRoot:      %{_tmppath}/%{name}-%{version}-%{release}-buildroot

Requires:  java >= 0:1.6.0
Requires:  sun-jaxb-2.1-api
Requires:  sun-jaxb-2.1-impl
Requires(post):   jpackage-utils >= 0:1.7.5
Requires(postun): jpackage-utils >= 0:1.7.5


%description
Apache XJC utilities.

%package javadoc
Summary:        Javadoc for %{name}
Group:          Development/Documentation

%description javadoc
%{summary}.

%prep
%setup -q -n xjc-utils-%{version}
%patch0 -b .sav0

%build
cp %{SOURCE1} maven2-settings.xml
sed -i -e "s|<url>__JPP_URL_PLACEHOLDER__</url>|<url>file://`pwd`/m2_repo/repository</url>|g" maven2-settings.xml
sed -i -e "s|<url>__JAVADIR_PLACEHOLDER__</url>|<url>file://`pwd`/external_repo</url>|g" maven2-settings.xml
sed -i -e "s|<url>__MAVENREPO_DIR_PLACEHOLDER__</url>|<url>file://`pwd`/m2_repo/repository</url>|g" maven2-settings.xml
sed -i -e "s|<url>__MAVENDIR_PLUGIN_PLACEHOLDER__</url>|<url>file:///usr/share/maven2/plugins</url>|g" maven2-settings.xml
sed -i -e "s|<url>__ECLIPSEDIR_PLUGIN_PLACEHOLDER__</url>|<url>file:///usr/share/eclipse/plugins</url>|g" maven2-settings.xml

mkdir external_repo
ln -s %{_javadir} external_repo/JPP
mkdir -p m2_repo/repository
export MAVEN_REPO_LOCAL=$(pwd)/m2_repo/repository

export SETTINGS=$(pwd)/maven2-settings.xml
export DEPMAP=%{SOURCE2}

mvn-jpp -e \
        -s $SETTINGS \
        -Dmaven.repo.local=$MAVEN_REPO_LOCAL \
        -Dmaven2.jpp.depmap.file=%{SOURCE2} \
        install 

mvn-jpp -e \
        -s $SETTINGS \
        -Dmaven.repo.local=$MAVEN_REPO_LOCAL \
        -Dmaven2.jpp.depmap.file=%{SOURCE2} \
        javadoc:aggregate 

%install
rm -rf $RPM_BUILD_ROOT
# jars
install -d -m 755 $RPM_BUILD_ROOT%{_javadir}/
install -d -m 755 $RPM_BUILD_ROOT%{_datadir}/maven2/poms

install -m 644 pom.xml \
  $RPM_BUILD_ROOT%{_datadir}/maven2/poms/JPP-%{name}.pom
%add_to_maven_depmap org.apache.cxf.xjc-utils xjc-utils %{version} JPP %{name}

install -m 644 boolean/target/cxf-xjc-boolean-%{version}.jar \
  $RPM_BUILD_ROOT%{_javadir}/cxf-xjc-boolean-%{version}.jar
install -m 644 boolean/pom.xml \
  $RPM_BUILD_ROOT%{_datadir}/maven2/poms/JPP-cxf-xjc-boolean.pom
%add_to_maven_depmap org.apache.cxf.xjcplugins cxf-xjc-boolean %{version} JPP cxf-xjc-boolean

install -m 644 boolean-test/target/cxf-xjc-boolean-test-%{version}.jar \
  $RPM_BUILD_ROOT%{_javadir}/cxf-xjc-boolean-test-%{version}.jar
install -m 644 boolean-test/pom.xml \
  $RPM_BUILD_ROOT%{_datadir}/maven2/poms/JPP-cxf-xjc-boolean-test.pom
%add_to_maven_depmap org.apache.cxf.xjcplugins.tests cxf-xjc-boolean-test %{version} JPP cxf-xjc-boolean-test

install -m 644 bug671/target/cxf-xjc-bug671-%{version}.jar \
  $RPM_BUILD_ROOT%{_javadir}/cxf-xjc-bug671-%{version}.jar
install -m 644 bug671/pom.xml \
  $RPM_BUILD_ROOT%{_datadir}/maven2/poms/JPP-cxf-xjc-bug671.pom
%add_to_maven_depmap org.apache.cxf.xjcplugins cxf-xjc-bug671 %{version} JPP cxf-xjc-bug671

install -m 644 cxf-xjc-plugin/target/cxf-xjc-plugin-%{version}.jar \
  $RPM_BUILD_ROOT%{_javadir}/cxf-xjc-plugin-%{version}.jar
install -m 644 cxf-xjc-plugin/pom.xml \
  $RPM_BUILD_ROOT%{_datadir}/maven2/poms/JPP-cxf-xjc-plugin.pom
%add_to_maven_depmap org.apache.cxf cxf-xjc-plugin %{version} JPP cxf-xjc-plugin

install -m 644 dv/target/cxf-xjc-dv-%{version}.jar \
  $RPM_BUILD_ROOT%{_javadir}/cxf-xjc-dv-%{version}.jar
install -m 644 dv/pom.xml \
  $RPM_BUILD_ROOT%{_datadir}/maven2/poms/JPP-cxf-xjc-dv.pom
%add_to_maven_depmap org.apache.cxf.xjcplugins cxf-xjc-dv %{version} JPP cxf-xjc-dv

install -m 644 dv-test/target/cxf-xjc-dv-test-%{version}.jar \
  $RPM_BUILD_ROOT%{_javadir}/cxf-xjc-dv-test-%{version}.jar
install -m 644 dv-test/pom.xml \
  $RPM_BUILD_ROOT%{_datadir}/maven2/poms/JPP-cxf-xjc-dv-test.pom
%add_to_maven_depmap org.apache.cxf.xjcplugins.tests cxf-xjc-dv-test %{version} JPP cxf-xjc-dv-test

install -m 644 property-listener/target/cxf-xjc-pl-%{version}.jar \
  $RPM_BUILD_ROOT%{_javadir}/cxf-xjc-pl-%{version}.jar
install -m 644 property-listener/pom.xml \
  $RPM_BUILD_ROOT%{_datadir}/maven2/poms/JPP-cxf-xjc-pl.pom
%add_to_maven_depmap org.apache.cxf.xjcplugins cxf-xjc-pl %{version} JPP cxf-xjc-pl

install -m 644 ts/target/cxf-xjc-ts-%{version}.jar \
  $RPM_BUILD_ROOT%{_javadir}/cxf-xjc-ts-%{version}.jar
install -m 644 ts/pom.xml \
  $RPM_BUILD_ROOT%{_datadir}/maven2/poms/JPP-cxf-xjc-ts.pom
%add_to_maven_depmap org.apache.cxf.xjcplugins cxf-xjc-ts %{version} JPP cxf-xjc-ts

install -m 644 ts-test/target/cxf-xjc-ts-test-%{version}.jar \
  $RPM_BUILD_ROOT%{_javadir}/cxf-xjc-ts-test-%{version}.jar
install -m 644 ts-test/pom.xml \
  $RPM_BUILD_ROOT%{_datadir}/maven2/poms/JPP-cxf-xjc-ts-test.pom
%add_to_maven_depmap org.apache.cxf.xjcplugins.tests cxf-xjc-ts-test %{version} JPP cxf-xjc-ts-test

install -m 644 wsdlextension/target/cxf-xjc-wsdlextension-%{version}.jar \
  $RPM_BUILD_ROOT%{_javadir}/cxf-xjc-wsdlextension-%{version}.jar
install -m 644 wsdlextension/pom.xml \
  $RPM_BUILD_ROOT%{_datadir}/maven2/poms/JPP-cxf-xjc-wsdlextension.pom
%add_to_maven_depmap org.apache.cxf.xjcplugins cxf-xjc-wsdlextension %{version} JPP cxf-xjc-wsdlextension

install -m 644 wsdlextension-test/target/cxf-xjc-wsdlextension-test-%{version}.jar \
  $RPM_BUILD_ROOT%{_javadir}/cxf-xjc-wsdlextension-test-%{version}.jar
install -m 644 wsdlextension-test/pom.xml \
  $RPM_BUILD_ROOT%{_datadir}/maven2/poms/JPP-cxf-xjc-wsdlextension-test.pom
%add_to_maven_depmap org.apache.cxf.xjcplugins.teswsdlextension cxf-xjc-wsdlextension-test %{version} JPP cxf-xjc-wsdlextension-test


(cd $RPM_BUILD_ROOT%{_javadir} && for jar in *-%{version}*; do ln -sf ${jar} `echo $jar| sed  "s|-%{version}||g"`; done)

# javadoc
install -d -m 755 $RPM_BUILD_ROOT%{_javadocdir}/%{name}-%{version}

install -d -m 755 $RPM_BUILD_ROOT%{_javadocdir}/%{name}-%{version}
cp -pr target/site/apidocs/* $RPM_BUILD_ROOT%{_javadocdir}/%{name}-%{version}/
ln -s %{name}-%{version} $RPM_BUILD_ROOT%{_javadocdir}/%{name} # ghost symlink

%clean
rm -rf $RPM_BUILD_ROOT

%post
%update_maven_depmap

%postun 
%update_maven_depmap

%files 
%defattr(-,root,root,-)
%{_javadir}/*.jar
%{_datadir}/maven2/poms/*
%{_mavendepmapfragdir}/*

%files javadoc
%defattr(-,root,root,-)
%doc %{_javadocdir}/%{name}-%{version}
%doc %{_javadocdir}/%{name}

%changelog
* Tue Feb 05 2013 Ralph Apel <r.apel at r-apel.de> - 0:2.4.0-2
- Prevent xzpayload problem

* Fri Jan 11 2013 Ralph Apel <r.apel at r-apel.de> - 0:2.4.0-1
- First release

